/*
This file contains programming code extracted from the Yahoo! Picture Frame Widget

COPYRIGHT (c) 2006 YAHOO! INC.

The following BSD License applies to the programming code included in this file.  

(1)	Redistributions of source code must retain the above copyright
notice, this list of conditions, and the following disclaimer.
(2)	Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the
distribution.
(3) 	Neither the name of Yahoo! nor the names of its contributors may
be used to endorse or promote products derived from the Yahoo! Widgets
without specific prior written permission of Yahoo!.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

var vitalityDoc = XMLDOM.parse( filesystem.readFile("Resources/vitality.xml") );

function buildVitality(src, srcWidth, srcHeight, theText)
//function setPictureFrameVitality(image)
{
	if( ! widget.dockOpen ) { return; }
	
	var newWidth, newHeight, vDiff, vOffset, hDiff, hOffset;
	var doc = vitalityDoc;
	var pic = doc.getElementById('mainpic');
	pic.setAttribute("src",src);
	/* crop'n'resize:
		find shortest dimension, resize to 74/68 as appropriate
		for longest dimension, calculate new size in same aspect ratio
		find differnce betwen 74/68 and new size
		set hOffset/vOffset by 1/2 differnce
	*/
	if (srcWidth < srcHeight)
	{
		// "tall" image: set width to maximum
		newWidth = 74;
		newHeight = (srcHeight/srcWidth) * 74;
		vDiff = 68 - newHeight;
		vOffset = vDiff/2;
		pic.setAttribute("hOffset",0);
		pic.setAttribute("vOffset",vOffset);
		pic.setAttribute("height",newHeight);
		pic.setAttribute("width",newWidth);
	}
	else
	{
		// "wide" image: set height to maximum
		newHeight = 68;
		newWidth = (srcWidth/srcHeight) * 68;
		hDiff = 74 - newWidth;
		hOffset = hDiff/2;
		pic.setAttribute("hOffset",hOffset);
		pic.setAttribute("vOffset",0);
		pic.setAttribute("height",newHeight);
		pic.setAttribute("width",newWidth);
	}			

	var mode = doc.getElementById('maintext');
	mode.setAttribute("hOffset","37");
	mode.setAttribute("vOffset","66");
	mode.setAttribute("hAlign","center");
	mode.setAttribute("style","font-family: Arial;font-size: 11px; font-weight: bold; color: black;");
	mode.setAttribute("data", theText);

	widget.setDockItem(doc,"fade");					
}
